namespace iTextSharp.text.html
{

    /// <summary>
    /// A class that contains all the possible tagnames and their attributes.
    /// </summary>
    public static class HtmlTags
    {
        /// <summary>
        /// attribute of paragraph/image/table tag
        /// </summary>
        public const string ALIGN = "align";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_BASELINE = "Baseline";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_BOTTOM = "Bottom";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_CENTER = "Center";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_JUSTIFIED = "Justify";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_LEFT = "Left";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_MIDDLE = "Middle";

        /// <summary>
        /// alignment attribute values
        /// </summary>
        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_RIGHT = "Right";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string ALIGN_TOP = "Top";

        /// <summary>
        /// attribute of the image tag
        /// </summary>
        public const string ALT = "alt";

        /// <summary>
        /// the anchor tag
        /// </summary>
        public const string ANCHOR = "a";

        /// <summary>
        /// attribute of the root tag
        /// </summary>
        public const string AUTHOR = "author";

        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string B = "b";

        /// <summary>
        /// attribute of the table/cell tag
        /// </summary>
        public const string BACKGROUNDCOLOR = "bgcolor";

        /// <summary>
        /// the body tag.
        /// </summary>
        public const string BODY = "body";

        /// <summary>
        /// attribute of the table/cell tag
        /// </summary>
        public const string BORDERCOLOR = "bordercolor";

        /// <summary>
        /// attribute of the table/cell tag
        /// </summary>
        public const string BORDERWIDTH = "border";

        /// <summary>
        /// attribute of the table/cell tag
        /// </summary>
        public const string BOTTOM = "bottom";

        /// <summary>
        /// This is a possible HTML attribute for the BODY tag.
        /// </summary>
        public const string BOTTOMMARGIN = "bottommargin";

        /// <summary>
        /// the cell tag
        /// </summary>
        public const string CELL = "td";

        /// <summary>
        /// attribute of the table tag
        /// </summary>
        public const string CELLPADDING = "cellpadding";

        /// <summary>
        /// attribute of the table tag
        /// </summary>
        public const string CELLSPACING = "cellspacing";

        /// <summary>
        /// the chunk tag
        /// </summary>
        public const string CHUNK = "font";

        /// <summary>
        /// Phrases, Anchors, Lists and Paragraphs
        /// </summary>
        /// <summary>
        /// the phrase tag
        /// </summary>
        public const string CODE = "code";

        /// <summary>
        /// attribute of the chunk/table/cell tag
        /// </summary>
        public const string COLOR = "color";

        /// <summary>
        /// attribute of the cell tag
        /// </summary>
        public const string COLSPAN = "colspan";

        /// <summary>
        /// attribute of the table tag
        /// </summary>
        public const string COLUMNS = "cols";

        /// <summary>
        /// This is a possible HTML attribute for the HEAD tag.
        /// </summary>
        public const string CONTENT = "content";

        /// <summary>
        /// the possible value of an alignment attribute
        /// </summary>
        public const string DEFAULT = "Default";

        /// <summary>
        /// The DIV tag.
        /// </summary>
        public const string DIV = "div";

        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string EM = "em";

        /// <summary>
        /// attribute of the chunk tag
        /// </summary>
        public const string FONT = "face";

        /// <summary>
        /// the head tag
        /// </summary>
        public const string HEAD = "head";

        /// <summary>
        /// attribute of the cell tag
        /// </summary>
        public const string HEADERCELL = "th";

        /// <summary>
        /// attribute of the cell tag
        /// </summary>
        public const string HORIZONTALALIGN = "align";

        /// <summary>
        /// the possible value of a tag
        /// </summary>
        public const string HORIZONTALRULE = "hr";

        /// <summary>
        /// the root tag.
        /// </summary>
        public const string HTML = "html";
        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string I = "i";

        /// <summary>
        /// the image tag
        /// </summary>
        public const string IMAGE = "img";

        /// <summary>
        /// This is a possible value for the LANGUAGE attribute.
        /// </summary>
        public const string JAVASCRIPT = "JavaScript";

        /// <summary>
        /// This is a possible HTML attribute for the BODY tag
        /// </summary>
        public const string JAVASCRIPT_ONLOAD = "onLoad";

        /// <summary>
        /// This is a possible HTML attribute for the BODY tag
        /// </summary>
        public const string JAVASCRIPT_ONUNLOAD = "onUnLoad";

        /// <summary>
        /// attribute of the root tag
        /// </summary>
        public const string KEYWORDS = "keywords";

        /// <summary>
        /// This is a possible HTML attribute for the SCRIPT tag.
        /// </summary>
        public const string LANGUAGE = "language";

        /// <summary>
        /// attribute of chapter/section/paragraph/table/cell tag
        /// </summary>
        public const string LEFT = "left";

        /// <summary>
        /// This is a possible HTML attribute for the BODY tag.
        /// </summary>
        public const string LEFTMARGIN = "leftmargin";

        /// <summary>
        /// The LINK tag.
        /// </summary>
        public const string LINK = "link";

        /// <summary>
        /// the listitem tag
        /// </summary>
        public const string LISTITEM = "li";

        /// <summary>
        /// the meta tag
        /// </summary>
        public const string META = "meta";

        /// <summary>
        /// attribute of anchor tag
        /// </summary>
        public const string NAME = "name";

        /// <summary>
        /// the newpage tag
        /// </summary>
        public const string NEWLINE = "br";

        /// <summary>
        /// attribute of the cell tag
        /// </summary>
        public const string NOWRAP = "nowrap";

        /// <summary>
        /// the list tag
        /// </summary>
        public const string ORDEREDLIST = "ol";

        /// <summary>
        /// the paragraph tag
        /// </summary>
        public const string PARAGRAPH = "p";

        /// <summary>
        /// attribute of the image tag
        /// </summary>
        public const string PLAINHEIGHT = "height";

        /// <summary>
        /// attribute of the image tag
        /// </summary>
        public const string PLAINWIDTH = "width";

        /// <summary>
        /// This is a possible HTML attribute for auto-formated
        /// @since 2.1.3
        /// </summary>
        public const string PRE = "pre";

        /// <summary>
        /// attribute of anchor tag
        /// </summary>
        public const string REFERENCE = "href";

        /// <summary>
        /// This is a possible HTML attribute for the LINK tag.
        /// </summary>
        public const string REL = "rel";

        /// <summary>
        /// attribute of chapter/section/paragraph/table/cell tag
        /// </summary>
        public const string RIGHT = "right";

        /// <summary>
        /// This is a possible HTML attribute for the BODY tag.
        /// </summary>
        public const string RIGHTMARGIN = "rightmargin";

        /// <summary>
        /// the cell tag
        /// </summary>
        public const string ROW = "tr";

        /// <summary>
        /// attribute of the cell tag
        /// </summary>
        public const string ROWSPAN = "rowspan";

        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string S = "s";

        /// <summary>
        /// the script tag.
        /// </summary>
        public const string SCRIPT = "script";

        /// <summary>
        /// Chunks
        /// </summary>
        /// <summary>
        /// attribute of the chunk tag
        /// </summary>
        public const string SIZE = "point-size";

        /// <summary>
        /// The SPAN tag.
        /// </summary>
        public const string SPAN = "span";

        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string STRONG = "strong";

        /// <summary>
        /// This is used for inline css style information
        /// </summary>
        public const string STYLE = "style";

        /// <summary>
        /// This is a possible HTML attribute.
        /// </summary>
        public const string STYLESHEET = "stylesheet";

        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string SUB = "sub";

        /// <summary>
        /// attribute of the root tag
        /// </summary>
        public const string SUBJECT = "subject";
        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string SUP = "sup";

        /// <summary>
        /// the table tag
        /// </summary>
        public const string TABLE = "table";

        /// <summary>
        /// This is a possible HTML attribute for the LINK tag.
        /// </summary>
        public const string TEXT_CSS = "text/css";

        /// <summary>
        /// the title tag.
        /// </summary>
        public const string TITLE = "title";
        /// <summary>
        /// attribute of the table/cell tag
        /// </summary>
        public const string TOP = "top";

        /// <summary>
        /// This is a possible HTML attribute for the BODY tag.
        /// </summary>
        public const string TOPMARGIN = "topmargin";
        /// <summary>
        /// This is a possible HTML attribute for the LINK tag.
        /// </summary>
        public const string TYPE = "type";

        /// <summary>
        /// some phrase tag
        /// </summary>
        public const string U = "u";

        /// <summary>
        /// the list tag
        /// </summary>
        public const string UNORDEREDLIST = "ul";

        /// <summary>
        /// Misc
        /// </summary>
        /// <summary>
        /// attribute of the image tag
        /// </summary>
        public const string URL = "src";

        /// <summary>
        /// the phrase tag
        /// </summary>
        public const string VAR = "var";
        /// <summary>
        /// attribute of the cell tag
        /// </summary>
        public const string VERTICALALIGN = "valign";

        /// <summary>
        /// tables/cells
        /// </summary>
        /// <summary>
        /// attribute of the table/cell tag
        /// </summary>
        public const string WIDTH = "width";

        /// <summary>
        /// attribute of anchor tag
        /// </summary>
        public static readonly string[] H = { "h1", "h2", "h3", "h4", "h5", "h6" };
    }
}